<template>
  <div>
    <horizontal :options="options" :height="300" :chart-data="datacollection" />
  </div>
</template>

<script>
import horizontal from '@/components/chart/horizontalBar.js'
import covertDate from '@/mixins/formateDate'
export default {
  mixins: [covertDate],
  components: {
    horizontal,
  },
  props: {
    setDataDate: Number,
  },
  data() {
    return {
      datacollection: null,
      options: null,
      setTotalData: [],
      setLabel: [],
      setBGColor: [],
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    getdashboardTime() {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.setLabel,
        datasets: [
          {
            label: 'Actual',
            backgroundColor: this.setBGColor,
            data: this.setTotalData,
          },
        ],
      }
      this.options = {
        legend: {
          display: false,
          labels: {
            fontColor: 'rgb(255, 99, 132)',
          },
        },
        responsive: true,
        maintainAspectRatio: false,
        height: '350',
        width: '200',
        scales: {
          fontColor: '#8a18e7',
          fontSize: 20,
          yAxes: [
            {
              fontColor: '#8a18e7',
              fontSize: 20,
              ticks: {
                beginAtZero: true,
                min: 0,
                stepSize: 500,
              },
            },
          ],
        },
        plugins: {
          datalabels: {
            formatter: function (value) {
              if (value == 0) {
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },
      }
    },
    async getDataAxios(
      timeVal = new Date(),
      expensestable = 0,
      expensestype = 0
    ) {
      if (expensestable) {
        const dateNow = new Date(timeVal)

        const weekNow = dateNow.getDay() // หาวันของ Week
        const oneDay = 86400000

        const dayStart = dateNow.getTime() - oneDay * weekNow
        const dayEnd = dateNow.getTime() + oneDay * (6 - weekNow)

        const dataRes = this.totalTypeMulti(expensestable, dayStart, dayEnd)
        const countName = expensestype.map((x) => x.name).length

        this.setTotalData = this.setArray(dataRes, countName)
        this.setLabel = expensestype.map((x) => x.name)
        this.setBGColor = this.setObjectBG(countName)

        this.fillData()
      }
    },
    setArray(objData, coutName) {
      const arrayDeserts = new Array(coutName)

      for (let i = 0; i < coutName; i++) {
        objData.forEach((res) => {
          if (res.id - 1 == i) {
            if (arrayDeserts[i] > 0) {
              arrayDeserts[i] = arrayDeserts[i] + res.price
            } else {
              arrayDeserts[i] = res.price
            }
          }
        })
        if (arrayDeserts[i] == null) {
          arrayDeserts[i] = ''
        }
      }
      return arrayDeserts
    },
    setObjectBG(typeName) {
      let setArrayBGColor = []
      for (let i = 0; i < typeName; i++) {
        const setData = this.bgColor(i)
        setArrayBGColor = [...setArrayBGColor, setData]
      }
      return setArrayBGColor
    },
  },
}
</script>
